'use strict';

/*
 * Copy this file to ./sscce.js
 * Add code from issue
 * npm run sscce-{dialect}
 */

const Sequelize = require('./index');
const sequelize = require('./test/support').createSequelizeInstance();

const Clientfile= sequelize.define('clientfile', {
  id: {
    type: Sequelize.UUID,
    defaultValue: Sequelize.UUIDV4,
    primaryKey: true
  }
})

const Mission = sequelize.define('mission', {
  id: {
    type: Sequelize.UUID,
    defaultValue: Sequelize.UUIDV4,
    primaryKey: true
  },
  startDate: Sequelize.DATE
})

const Building = sequelize.define('building', {
  id: {
    type: Sequelize.UUID,
    defaultValue: Sequelize.UUIDV4,
    primaryKey: true
  }
})

Clientfile.belongsTo(Office)
Clientfile.hasOne(Mission)
Clientfile.hasOne(Building)

(async () => {
  await Clientfile.sync()
  await Mission.sync()
  await Building.sync()

  const clientfiles = await Clientfile.findAll({
      attributes: [],
      include: [
      {
          association: 'mission',
          attributes: ['id'],
          where: {
            startDate: {
              [Op.gte]: new Date(),
              [Op.lte]: new Date()
             }
          }
        },
        {
          association: 'building',
          attributes: ['id']
        }
      ]
  })
})()